• Home
  • Category: Uncategorized

django.core.exceptions.ImproperlyConfigured: Error loading MySQLdb module. Did you install mysqlclient?

(venv) [email protected]:~/myappointments$ sudo apt-get install python3-mysql.connector
Reading package lists... Done
Building dependency tree       
Reading state information... Done
The following NEW packages will be installed:
  python3-mysql.connector
0 upgraded, 1 newly installed, 0 to remove and 11 not upgraded.
Need to get 98.2 kB of archives.
After this operation, 616 kB of additional disk space will be used.
Get:1 http://in.archive.ubuntu.com/ubuntu bionic/universe i386 python3-mysql.connector all 2.1.6-1 [98.2 kB]
Fetched 98.2 kB in 3s (29.0 kB/s)                  
Selecting previously unselected package python3-mysql.connector.
(Reading database ... 203360 files and directories currently installed.)
Preparing to unpack .../python3-mysql.connector_2.1.6-1_all.deb ...
Unpacking python3-mysql.connector (2.1.6-1) ...
Setting up python3-mysql.connector (2.1.6-1) ...
(venv) [email protected]:~/myappointments$ python3 manage.py runserver
Unhandled exception in thread started by <function check_errors.<locals>.wrapper at 0xb656c5cc>
Traceback (most recent call last):
  File "/home/joel/myappointments/venv/lib/python3.6/site-packages/django/db/backends/mysql/base.py", line 15, in <module>
    import MySQLdb as Database
  File "/home/joel/myappointments/venv/lib/python3.6/site-packages/MySQLdb/__init__.py", line 18, in <module>
    import _mysql
ModuleNotFoundError: No module named '_mysql'

The above exception was the direct cause of the following exception:

Traceback (most recent call last):
  File "/home/joel/myappointments/venv/lib/python3.6/site-packages/django/utils/autoreload.py", line 225, in wrapper
    fn(*args, **kwargs)
  File "/home/joel/myappointments/venv/lib/python3.6/site-packages/django/core/management/commands/runserver.py", line 109, in inner_run
    autoreload.raise_last_exception()
  File "/home/joel/myappointments/venv/lib/python3.6/site-packages/django/utils/autoreload.py", line 248, in raise_last_exception
    raise _exception[1]
  File "/home/joel/myappointments/venv/lib/python3.6/site-packages/django/core/management/__init__.py", line 337, in execute
    autoreload.check_errors(django.setup)()
  File "/home/joel/myappointments/venv/lib/python3.6/site-packages/django/utils/autoreload.py", line 225, in wrapper
    fn(*args, **kwargs)
  File "/home/joel/myappointments/venv/lib/python3.6/site-packages/django/__init__.py", line 24, in setup
    apps.populate(settings.INSTALLED_APPS)
  File "/home/joel/myappointments/venv/lib/python3.6/site-packages/django/apps/registry.py", line 112, in populate
    app_config.import_models()
  File "/home/joel/myappointments/venv/lib/python3.6/site-packages/django/apps/config.py", line 198, in import_models
    self.models_module = import_module(models_module_name)
  File "/home/joel/myappointments/venv/lib/python3.6/importlib/__init__.py", line 126, in import_module
    return _bootstrap._gcd_import(name[level:], package, level)
  File "<frozen importlib._bootstrap>", line 994, in _gcd_import
  File "<frozen importlib._bootstrap>", line 971, in _find_and_load
  File "<frozen importlib._bootstrap>", line 955, in _find_and_load_unlocked
  File "<frozen importlib._bootstrap>", line 665, in _load_unlocked
  File "<frozen importlib._bootstrap_external>", line 678, in exec_module
  File "<frozen importlib._bootstrap>", line 219, in _call_with_frames_removed
  File "/home/joel/myappointments/appointments/models.py", line 3, in <module>
    from django.contrib.auth.models import User
  File "/home/joel/myappointments/venv/lib/python3.6/site-packages/django/contrib/auth/models.py", line 2, in <module>
    from django.contrib.auth.base_user import AbstractBaseUser, BaseUserManager
  File "/home/joel/myappointments/venv/lib/python3.6/site-packages/django/contrib/auth/base_user.py", line 47, in <module>
    class AbstractBaseUser(models.Model):
  File "/home/joel/myappointments/venv/lib/python3.6/site-packages/django/db/models/base.py", line 101, in __new__
    new_class.add_to_class('_meta', Options(meta, app_label))
  File "/home/joel/myappointments/venv/lib/python3.6/site-packages/django/db/models/base.py", line 305, in add_to_class
    value.contribute_to_class(cls, name)
  File "/home/joel/myappointments/venv/lib/python3.6/site-packages/django/db/models/options.py", line 203, in contribute_to_class
    self.db_table = truncate_name(self.db_table, connection.ops.max_name_length())
  File "/home/joel/myappointments/venv/lib/python3.6/site-packages/django/db/__init__.py", line 33, in __getattr__
    return getattr(connections[DEFAULT_DB_ALIAS], item)
  File "/home/joel/myappointments/venv/lib/python3.6/site-packages/django/db/utils.py", line 202, in __getitem__
    backend = load_backend(db['ENGINE'])
  File "/home/joel/myappointments/venv/lib/python3.6/site-packages/django/db/utils.py", line 110, in load_backend
    return import_module('%s.base' % backend_name)
  File "/home/joel/myappointments/venv/lib/python3.6/importlib/__init__.py", line 126, in import_module
    return _bootstrap._gcd_import(name[level:], package, level)
  File "/home/joel/myappointments/venv/lib/python3.6/site-packages/django/db/backends/mysql/base.py", line 20, in <module>
    ) from err
django.core.exceptions.ImproperlyConfigured: Error loading MySQLdb module.
Did you install mysqlclient?

This happened in a venv. The package which had been installed outside of venv needed to be reinstalled:

pip3 uninstall mysqlclient
pip3 install mysqlclient